#ifndef PACKAGE_H
#define PACKAGE_H

#include "Point.h"

class Package
{
public:
  Package(int id = -1) : mId(id), mWeight(0) {}
  Package(int id, Point pt, int w) : mId(id), mWeight(w), mDest(pt) {}
  Package(const Package& pkg) { *this = pkg; }

  Package& operator=(const Package& pkg)
  { mId = pkg.mId; mWeight = pkg.mWeight; mDest = pkg.mDest; return *this; }

  int id() const { return mId; }
  int weight() const { return mWeight; }
  Point dest() const { return mDest; }

private:
  int mId;
  int mWeight;
  Point mDest;
};

#endif

