#ifndef PATH_H
#define PATH_H

#include "Point.h"

class Path : public vector<Point>
{
public:
  Path() : mPos(0) {}
  Path(const Point& pt) : mPos(0) {push_back(pt); }

  Point currPos() const { return (*this)[mPos]; }
  size_type inc()      { return ++mPos; }
  bool atDest() const  { return mPos == size(); }
  Point dest() const   { return back(); }

  void print()
  {
    cout << "Path: ";
    for (int i = 0; i < size(); i++)
    {
      if (i)
        cout << ",";
      cout << "(" << (*this)[i].x() << "," << (*this)[i].y() << ")";
    }
    cout << endl;
  }

  static char getDir(const Point& pt1, const Point& pt2)
  {
    if (pt2.x() < pt1.x())
      return 'W';
    if (pt2.x() > pt1.x())
      return 'E';
    if (pt2.y() < pt1.y())
      return 'S';
    if (pt2.y() > pt1.y())
      return 'N';

    return ' ';
  }

  void printNice()
  {
    if (!size())
    {
      cout << "Empty Path" << endl;
      return;
    }
    cout << "Path from (" << front().x() << "," << front().y() << ") to ("
         << back().x() << "," << back().y() << "):";

    for (int i = 1; i < size(); i++)
    {
      cout << getDir((*this)[i-1], (*this)[i]);
    }

    cout << "." << endl;
  }

private:
  size_type mPos;
};

#endif

