#ifndef PLAYER_H
#define PLAYER_H

#include "common.h"
#include "Network.h"
#include "Board.h"
#include "Path.h"

class Player : public Robot
{
public:
  enum Action { eMove = 0, eDrop, ePick };

  Player(Network& net, 
         Board& bd,
         int id,
         int maxw,
         int money) 
    : Robot(id)
    , mNet(net)
    , mBoard(bd)
    , mId(id)
    , mMaxw(maxw)
    , mMoney(money)
  {
  }

  void run();

  // Reads the #<player> <actions>
  void readServerResponse();

  // Reads list of packages
  void readPackages();

  // Makes a move
  void makeMove();

  // Gets available weight
  int getAvailWeight()
  {
    int ret = mMaxw;
    for (int i = 0; i < mPkgs.size(); i++)
      ret -= mPkgs[i].weight();

    return ret;
  }

private:
  Network& mNet;
  Board&   mBoard;
  int      mId;
  int      mMaxw;
  int      mMoney;
  Path     mRoute;

  int      mNextBid;
  Action   mTried;
};

#endif

