#ifndef POINT_H
#define POINT_H

class Point
{
public:
  Point() : mX(0), mY(0) {}
  Point(int x, int y) : mX(x), mY(y) {}
  Point(const Point& pt) { *this = pt; }

  Point& operator=(const Point& pt)
  { mX = pt.mX; mY = pt.mY; return *this; }

  Point operator+(const Point& pt) const
  { return Point(mX + pt.mX, mY + pt.mY); }

  Point operator-(const Point& pt) const
  { return Point(mX - pt.mX, mY - pt.mY); }

  bool operator==(const Point& pt) const
  { return mX == pt.mX && mY == pt.mY; }

  bool operator!=(const Point& pt) const
  { return mX != pt.mX || mY != pt.mY; }

  bool operator<(const Point& pt) const
  { return (mX < pt.mX) && (mY < pt.mY); }

  int x() const { return mX; }
  void x(int x) { mX = x; }
  int y() const { return mY; }
  void y(int y) { mY = y; }

private:
  int mX;
  int mY;
};

inline ostream& operator<<(ostream& o, const Point& p)
{ return o << "(" << p.x() << "," << p.y() << ")"; }

#endif

