#ifndef ROBOT_H
#define ROBOT_H

#include "common.h"
#include "Point.h"

class Robot
{
public:
  Robot(int id) : mId(id) {}

  int id() const { return mId; }
  Point pos() const { return mPos; }
  int numPkgs() const { return mPkgs.size(); }
  Package pkg(int i) const { return mPkgs[i]; }
  vector<Package> pkgs() const { return mPkgs; }

  Package getPkg(int id) const
  {
    for (vector<Package>::const_iterator it = mPkgs.begin();
         it != mPkgs.end();
         it++)
    {
      if (it->id() == id)
        return *it;
    }

    return Package();
  }

  void pickup(const Package& p) { mPkgs.push_back(p); }

  Package drop(int id)
  {
    for (vector<Package>::iterator it = mPkgs.begin();
         it != mPkgs.end();
         it++)
    {
      if (it->id() == id)
      {
        Package ret(*it);
        mPkgs.erase(it);
        return ret;
      }
    }
  }

  void pos(const Point& p) { mPos = p; }

protected:
  int mId;
  Point mPos;
  vector<Package> mPkgs;
};

#endif

