#include "common.h"
#include "Player.h"
#include "Network.h"
#include "Board.h"


int main(int argc, char* argv[])
{
  if (argc != 3)
  {
    cout << "Usage: " << argv[0] << " hostname port" << endl;
    return 1;
  }

  string host(argv[1]);
  istringstream iss(argv[2]);
  unsigned long port;
  iss >> port;
  Network net(host, port);
  net << "Player";
  string s;
  int x, y;
  net >> x >> y;
  vector<string> data;
  for (int i = 0; i < y; i++)
  {
    net >> s;
    data.push_back(s);
  }
  Board board(data);

  board.print();

  int id, maxw, money;
  net >> id >> maxw >> money;

  Player ply(net, board, id, maxw, money);

  ply.run();

  return 0;
}

